/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      ...
 *   Co-authors:
 *      ...
 *
 */

#ifndef _Answer_H__
#define _Answer_H__

#include "core/BaseObject.h"
#include "DialogPrereqs.h"
#include "core/XMLPort.h"
#include "core/CoreIncludes.h"
#include <string>

namespace orxonox
{
	/**
	@brief
    class containing the pc side of the Dialog

    this class contains one possible text option of the pc, it's id and the id of the reaction of the npc to this answer
	*/

	class _DialogExport Answer : public BaseObject
	{
		public:
			Answer(Context* context);
			
			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);

			void setAnswerId(const std::string& answerId); //xmlPort-Funktion, setzt AntwortId
			const std::string& getAnswerId() const;	//xmlPort-Funktion,	gibt AntwortId

			void setNextQuestion(const std::string& nextId); //xmlPort-Funktion, um Dialog zu beenden tag benutzen der von keiner Frage benutzt wird
			const std::string& getNextQuestion() const;	//xmlPort-Funktion, gibt Id der Folgefrage

			void setAnswer(const std::string& awns);	//xmlPort-Funktion, setzt Antworttext
			const std::string& getAnswer() const;	//xmlPort-Funktion,	gibt Antworttext

		private:
			std::string answerId_;	//!< id of the pc textoption	
			std::string answer_;	//!< string with the pc text
			std::string nextQuestionId_;	//!< id of the npc reaction to pc answer
	};
}

#endif
