/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      ...
 *   Co-authors:
 *      ...
 *
 */

#include "Question.h"
#include "core/CoreIncludes.h"

namespace orxonox
{

	RegisterClass(Question);

	Question::Question(Context* context) : BaseObject(context)
	{
		RegisterObject(Question);
	}

	void Question::XMLPort(Element& xmlement, XMLPort::Mode mode)
	{
		SUPER(Question, XMLPort, xmlement, mode);

		XMLPortParam(Question, "question", setQuestion, getQuestion, xmlement, mode);
		XMLPortParam(Question, "Id", setQuestionId, getQuestionId, xmlement, mode);

		XMLPortObject(Question, AnswerId, "answerIds", addAnswerId, getAnswerId, xmlement, mode);
	}

	void Question::setQuestionId(const std::string& Id)
	{
		this->questionId_ = Id;
	}

	const std::string& Question::getQuestionId() const
	{
		return this->questionId_;
	}

	void Question::setQuestion(const std::string& question)
	{
		this->question_ = question;
	}

	const std::string& Question::getQuestion() const
	{
		return this->question_;
	}

	void Question::addAnswerId(AnswerId* answerId)
	{
		this->answerIds_.push_back(answerId->getId());
	}

	AnswerId* Question::getAnswerId(unsigned int index) const
	{
		return nullptr;
	}

	const std::vector<std::string>& Question::getAnswerIds() const
	{
		return this->answerIds_;
	}
	
}
